/*
 * MEULineCommand.java
 * This represents the commands the user enters in the line number area.
 * Created on September 1, 2000, 9:14 PM
 * This is free open source software distributed under the IBM Public License found
 * on the World Wide Web at http://oss.software.ibm.com/developerworks/opensource/license10.html
 * Copyright *C* 2000, Jack J. Woehr, PO Box 51, Golden, CO 80402-0051 USA jax@well.com
 * Copyright *C* 2000, International Business Machines Corporation and others. All Rights Reserved.
 */

package com.SoftWoehr.JTOpenContrib.MEU;

/** Embodies the parsing of line commands entered in the
 * line number area.
 * @author jax
 * @version 1.0
 */
public class MEULineCommand extends Object {

  /** The line command entered by user.
   */
  public String command =null;
  /** Numeric argument to command or null
   */
  public Integer numericArg =null;

  /** Creates new MEULineCommand
   * @param cmd The text entered by user
   */
  public MEULineCommand (String cmd) {

    java.util.StringTokenizer st = new java.util.StringTokenizer (cmd, "0123456789");

    /* Try to get a string command */
    try {
      command = st.nextToken().toUpperCase();
    }
    catch (java.util.NoSuchElementException e) {
      command = null;
    }

    /* If there was no text command, reset to make sure we get the number, if any */
    if (null == command) {
      st = new java.util.StringTokenizer (cmd);
    }

    /* Try to get a numeric argument */
    try {
      numericArg = Integer.valueOf(st.nextToken(""));
    }
    catch (java.util.NoSuchElementException e) {
      numericArg = null;
    }
    catch (NumberFormatException e) {
      numericArg = null;
    }
  }
}
