/*
 * DataQueueTextFieldPanel.java
 *
 * Created on September 26, 2000, 6:00 PM
 * This is free open source software distributed under the IBM Public License found
 * on the World Wide Web at http://oss.software.ibm.com/developerworks/opensource/license10.html
 * Copyright *C* 2000, Jack J. Woehr, PO Box 51, Golden, CO 80402-0051 USA jax@well.com
 * Copyright *C* 2000, International Business Machines Corporation and others. All Rights Reserved.
 */

package com.SoftWoehr.JTOpenContrib.QCDemo;

import com.SoftWoehr.JTOpenContrib.connectionmgr.*;
import com.ibm.as400.access.*;
import com.ibm.as400.vaccess.DataQueueDocument;

/** A Panel with fields to allow connecting to and browsing a data queue.
 * @author jax
 * @version 1.2
 */
public class DataQueueTextFieldPanel extends javax.swing.JPanel implements ServiceClient {

  private Mgr manager;
  private ServiceRecord serviceRecord;
  private DataQueueDocument dataQueueDocument;
  private int functionType = 0;

  /** Indicates usage of this widget is to read data queues.
   */
  public static final int READ_DQ =0;
  /** Indicates usage of this widget is to peek data queues.
   */
  public static final int PEEK_DQ =1;
  /** Indicates usage of this widget is to write data queues.
   */
  public static final int WRITE_DQ =2;

  /** Creates new form DataQueueTextFieldPanel */
  public DataQueueTextFieldPanel() {
    initComponents ();
  }

  /** Creates new form DataQueueTextFieldPanel
   * @param mgr The connection manager providing connectivity for this widget.
   * @param funcType One of READ_DQ PEEK_DQ or WRITE_DQ.
   */
  public DataQueueTextFieldPanel(Mgr mgr, int funcType) {
    this();
    manager = mgr;
    functionType = funcType;
    setButtonType();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    sourcePanel = new javax.swing.JPanel ();
    serverLabel = new javax.swing.JLabel ();
    serverTextField = new javax.swing.JTextField ();
    libraryLabel = new javax.swing.JLabel ();
    libraryTextField = new javax.swing.JTextField ();
    qnameLabel = new javax.swing.JLabel ();
    qnameTextField = new javax.swing.JTextField ();
    jPanel2 = new javax.swing.JPanel ();
    qdataTextField = new javax.swing.JTextField ();
    doitButton = new javax.swing.JButton ();
    setLayout (new java.awt.GridLayout (2, 1));

    sourcePanel.setLayout (new java.awt.GridLayout (1, 6));

      serverLabel.setText ("Server");
      serverLabel.setToolTipText ("Enter Server name");
      serverLabel.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
  
      sourcePanel.add (serverLabel);
  
      serverTextField.setToolTipText ("Enter Server name");
      serverTextField.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          serverTextFieldActionPerformed (evt);
        }
      }
      );
  
      sourcePanel.add (serverTextField);
  
      libraryLabel.setText ("Library");
      libraryLabel.setToolTipText ("Enter Library name");
      libraryLabel.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
  
      sourcePanel.add (libraryLabel);
  
      libraryTextField.setToolTipText ("Enter Library name");
      libraryTextField.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          libraryTextFieldActionPerformed (evt);
        }
      }
      );
  
      sourcePanel.add (libraryTextField);
  
      qnameLabel.setText ("Queue");
      qnameLabel.setToolTipText ("Enter Queue name");
      qnameLabel.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
  
      sourcePanel.add (qnameLabel);
  
      qnameTextField.setToolTipText ("Enter Queue name");
      qnameTextField.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          qnameTextFieldActionPerformed (evt);
        }
      }
      );
  
      sourcePanel.add (qnameTextField);
  

    add (sourcePanel);

    jPanel2.setLayout (new java.awt.BorderLayout ());
    jPanel2.setToolTipText ("Queue textual data goes here.");

      qdataTextField.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          qdataTextFieldActionPerformed (evt);
        }
      }
      );
  
      jPanel2.add (qdataTextField, java.awt.BorderLayout.CENTER);
  
      doitButton.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          doitButtonActionPerformed (evt);
        }
      }
      );
  
      jPanel2.add (doitButton, java.awt.BorderLayout.WEST);
  

    add (jPanel2);

  }//GEN-END:initComponents

  private void qnameTextFieldActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_qnameTextFieldActionPerformed
    // Add your handling code here:
    reinstanceAll();
  }//GEN-LAST:event_qnameTextFieldActionPerformed

  private void doitButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_doitButtonActionPerformed
    // Add your handling code here:
    doDataQueue();
  }//GEN-LAST:event_doitButtonActionPerformed

  private void qdataTextFieldActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_qdataTextFieldActionPerformed
    // Add your handling code here:
    doDataQueue();
  }//GEN-LAST:event_qdataTextFieldActionPerformed

  private void serverTextFieldActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_serverTextFieldActionPerformed
    // Add your handling code here:
    reinstanceAll();
  }//GEN-LAST:event_serverTextFieldActionPerformed

  private void libraryTextFieldActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_libraryTextFieldActionPerformed
    // Add your handling code here:
    reinstanceAll();
  }//GEN-LAST:event_libraryTextFieldActionPerformed


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel sourcePanel;
  private javax.swing.JLabel serverLabel;
  private javax.swing.JTextField serverTextField;
  private javax.swing.JLabel libraryLabel;
  private javax.swing.JTextField libraryTextField;
  private javax.swing.JLabel qnameLabel;
  private javax.swing.JTextField qnameTextField;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JTextField qdataTextField;
  private javax.swing.JButton doitButton;
  // End of variables declaration//GEN-END:variables

  /** Perform the named dataqueue functionality */
  protected void doRead(){
    System.out.println("Data queue read.");
    if (null != dataQueueDocument) {
      dataQueueDocument.read();
    }
  }
  /** Perform the named dataqueue functionality */
  protected void doPeek(){
    System.out.println("Data queue peek.");
    if (null != dataQueueDocument) {
      dataQueueDocument.peek();
    }
  }
  /** Perform the named dataqueue functionality */
  protected void doWrite(){
    System.out.println("Data queue write.");
    if (null != dataQueueDocument) {
      dataQueueDocument.write();
    }
  }

  /** Perform the dataqueue functionality appropriate */
  protected void doDataQueue () {
    String temp = qdataTextField.getText();
    reinstanceAll();
    if (WRITE_DQ == functionType) {
      qdataTextField.setText(temp);
    }
    switch (functionType) {
      case READ_DQ :
      doRead();
      break;
      case PEEK_DQ :
      doPeek();
      break;
      case WRITE_DQ :
      doWrite();
      break;
      default:
      //
    }
  }

  /** Get the pathname representing what the user has entered
   * @return The pathname object representing the user's input.
   */
  public QSYSObjectPathName getQSYSObjectPathName () {
    QSYSObjectPathName pathName = null;
    String library = libraryTextField.getText();
    String qname   = qnameTextField.getText();
    if (null != library) {
      if (null != qname) {
        if (!library.equals("")) {
          if (!qname.equals("")) {
            pathName = new QSYSObjectPathName(library, qname, "DTAQ");
          }
        }
      }
    }
    return pathName;
  }

  /** See if any user entry has changed and if necessary and possible, reinstance data queue document.
   * Empty out text field if we're nulled out or ""'ed out.
   */
  protected void reinstanceDataQueueDocument () {
    if (null != serviceRecord) {
      QSYSObjectPathName pathName = getQSYSObjectPathName();
      if (null != pathName) { // User provided path name
        if (null != dataQueueDocument) { // But we already have a dataQueueDocument
          if (!dataQueueDocument.getPath().equals(pathName.getPath())
          || dataQueueDocument.getSystem() != serviceRecord.as400) { // If path or server have changed
            dataQueueDocument = new DataQueueDocument(serviceRecord.as400, pathName.getPath()); // reinstance
          }
        }
        else { // Didn't already have a data queue document
          dataQueueDocument = new DataQueueDocument(serviceRecord.as400, pathName.getPath());
        }
        qdataTextField.setDocument(dataQueueDocument); // Whatever, set that doc current in text field.
      } // End of non-null path provided
      else { // Null path provided
        dataQueueDocument = null; // Okay, user wants to discard.
        qdataTextField.setDocument(new javax.swing.text.PlainDocument()); // Text field lets loose of it.
      }
    }
    else { // No service record, nuttin' doin'.
      dataQueueDocument = null;
      qdataTextField.setDocument(new javax.swing.text.PlainDocument());
    }
  }

  /** See if server name or path has been changed by user and reinstance
   * appropriately.
   */
  protected void reinstanceAll() {
    reinstanceServer();
    reinstanceDataQueueDocument();
  }

  /** Set the button per function performed */
  protected void setButtonType () {
    switch (functionType) {
      case READ_DQ :
      doitButton.setText("Read");
      break;
      case PEEK_DQ :
      doitButton.setText("Peek");
      break;
      case WRITE_DQ :
      doitButton.setText("Write");
      break;
      default:
      doitButton.setText("??");
    }
  }

  /** Get new service record for new server name. If service record is
   * null aftewards, an exception was thrown.
   * @param newServerName Name of server to connect to.
   */
  protected void tryInstanceServiceRecord (String newServerName) {
    try {
      serviceRecord = manager.getService("mgr:" + newServerName + "/DATAQUEUE", this);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  /** Release the service record (if any) to the manager */
  protected void deinstanceServiceRecord () {
    if (null != serviceRecord) {
      try { // let go of the service from manager
        manager.freeService(serviceRecord);
      }
      catch (Exception e) {
        e.printStackTrace();
      }
      serviceRecord = null;
    }
  }

  /** Reinstance server from user text entry */
  protected void reinstanceServer() {
    reinstanceServer(serverTextField.getText());
  }

  /** From a server name reinstance server if necessary.
   * @param newServerName Name of server to connect to.
   */
  protected synchronized void reinstanceServer(String newServerName) {
    if (null != newServerName) {
      if (!newServerName.equals("")) {
        if (null != serviceRecord) {
          if (!newServerName.equals(serviceRecord.serverName)) {
            try { // let go of the service from manager
              manager.freeService(serviceRecord);
            }
            catch (Exception e) {
              e.printStackTrace();
            }
            serviceRecord = null;
            tryInstanceServiceRecord (newServerName);
          } // End Names did not match
        } // Service record not null
        else { // Service record was null
          tryInstanceServiceRecord (newServerName);
        }
      } // End name was not ""
      else { // Name was ""
        deinstanceServiceRecord ();
      } // End new name was ""
    } // End new name was not null
    else { // New name was null
      deinstanceServiceRecord ();
    }
  }

  /** Called by a Mgr, this function indicates that a service record supplied
   * earlier by the MGr to the ServiceClient instance will no longer be valid
   * after this call completes.
   * @param sr The service record which the Mgr is indicating will no longer be valid after the <B>relinquish</B> completes.
   */
  public void relinquish(ServiceRecord sr) {
    serviceRecord = null;
  }
}