/*
 * QCDataQueuePanel.java
 *
 * Created on September 26, 2000, 6:16 PM
 * This is free open source software distributed under the IBM Public License found
 * on the World Wide Web at http://oss.software.ibm.com/developerworks/opensource/license10.html
 * Copyright *C* 2000, Jack J. Woehr, PO Box 51, Golden, CO 80402-0051 USA jax@well.com
 * Copyright *C* 2000, International Business Machines Corporation and others. All Rights Reserved.
 */

package com.SoftWoehr.JTOpenContrib.QCDemo;
import com.SoftWoehr.JTOpenContrib.connectionmgr.*;

/** A panel to display multiple DataQueueTextFields allowing data queue browsing.
 * @author jax
 * @version 1.2
 */
public class QCDataQueuePanel extends javax.swing.JPanel {

  private Mgr manager;
  
  /** Creates new form QCDataQueuePanel */
  public QCDataQueuePanel() {
    initComponents ();
  }

  /** Creates new form QCDataQueuePanel ... Create a data queue panel allowing one to browse data
   * queues.
   * @param mgr The connection manager providing connectivity to this widget.
   */
  public QCDataQueuePanel(Mgr mgr) {
    manager = mgr;
    initComponents();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    dataQueueTextFieldPanel1 = new DataQueueTextFieldPanel(manager, DataQueueTextFieldPanel.READ_DQ);
    dataQueueTextFieldPanel2 = new DataQueueTextFieldPanel(manager, DataQueueTextFieldPanel.PEEK_DQ);
    dataQueueTextFieldPanel3 = new DataQueueTextFieldPanel(manager, DataQueueTextFieldPanel.WRITE_DQ);
    setLayout (new java.awt.GridLayout (3, 1));

    dataQueueTextFieldPanel1.setLayout (new java.awt.GridLayout (2, 3));


    add (dataQueueTextFieldPanel1);

    dataQueueTextFieldPanel2.setLayout (new java.awt.GridLayout (2, 3));


    add (dataQueueTextFieldPanel2);

    dataQueueTextFieldPanel3.setLayout (new java.awt.GridLayout (2, 3));


    add (dataQueueTextFieldPanel3);

  }//GEN-END:initComponents


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private com.SoftWoehr.JTOpenContrib.QCDemo.DataQueueTextFieldPanel dataQueueTextFieldPanel1;
  private com.SoftWoehr.JTOpenContrib.QCDemo.DataQueueTextFieldPanel dataQueueTextFieldPanel2;
  private com.SoftWoehr.JTOpenContrib.QCDemo.DataQueueTextFieldPanel dataQueueTextFieldPanel3;
  // End of variables declaration//GEN-END:variables

}