/*
 * QCNotebookPanel.java
 *
 * Created on July 12, 2000, 1:54 AM
 *
 * This is free open source software distributed under the IBM Public License found
 * on the World Wide Web at http://oss.software.ibm.com/developerworks/opensource/license10.html
 * Copyright *C* 2000, Jack J. Woehr, PO Box 51, Golden, CO 80402-0051 USA jax@well.com
 * Copyright *C* 2000, International Business Machines Corporation and others. All Rights Reserved.
 */

package com.SoftWoehr.JTOpenContrib.QCDemo;

/** A notebook to hold useful panels of as400.vaccess components.
 * @author jax
 * @version 1.0
 */
public class QCNotebookPanel extends javax.swing.JPanel {

  /** Our connection manager propagated through project. */
  private com.SoftWoehr.JTOpenContrib.connectionmgr.Mgr manager;
  private javax.swing.JFrame frame = null;

  /** Creates new form QCNotebookPanel */
  public QCNotebookPanel() {
    this(new com.SoftWoehr.JTOpenContrib.connectionmgr.Mgr ());
  }

  /** Creates new form QCNotebookPanel */
  public QCNotebookPanel(com.SoftWoehr.JTOpenContrib.connectionmgr.Mgr mgr) {
    manager = mgr;
    initComponents ();
    setManagers();
    qCSQLQueryBuilderPanel1.setResultTable(qCSQLResultSetTablePanel1);
    qCSQLQueryBuilderPanel1.setResultForm(qCSQLResultSetFormPanel1);
  }

  /** Creates new form QCNotebookPanel */
  public QCNotebookPanel
  (com.SoftWoehr.JTOpenContrib.connectionmgr.Mgr mgr, javax.swing.JFrame frm) {
    frame = frm;
    manager = mgr;
    initComponents ();
    setManagers();
    qCSQLQueryBuilderPanel1.setResultTable(qCSQLResultSetTablePanel1);
    qCSQLQueryBuilderPanel1.setResultForm(qCSQLResultSetFormPanel1);
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    jTabbedPane1 = new javax.swing.JTabbedPane ();
    qCCommandPanel1 = new com.SoftWoehr.JTOpenContrib.QCDemo.QCCommandPanel ();
    qCIFSPanel1 = new com.SoftWoehr.JTOpenContrib.QCDemo.QCIFSPanel (frame);
    qCUserListPanel1 = new com.SoftWoehr.JTOpenContrib.QCDemo.QCUserListPanel ();
    qCJobListPanel1 = new com.SoftWoehr.JTOpenContrib.QCDemo.QCJobListPanel ();
    qCPrinterListPanel1 = new com.SoftWoehr.JTOpenContrib.QCDemo.QCPrinterListPanel (frame);
    qCSpooledFileViewerPanel1 = new com.SoftWoehr.JTOpenContrib.QCDemo.QCSpooledFileViewerPanel ();
    qCSQLQueryBuilderPanel1 = new com.SoftWoehr.JTOpenContrib.QCDemo.QCSQLQueryBuilderPanel ();
    qCSQLResultSetTablePanel1 = new com.SoftWoehr.JTOpenContrib.QCDemo.QCSQLResultSetTablePanel ();
    qCSQLResultSetFormPanel1 = new com.SoftWoehr.JTOpenContrib.QCDemo.QCSQLResultSetFormPanel ();
    qCDataQueuePanel1 = new QCDataQueuePanel(manager);
    qCMgrViewer1 = new com.SoftWoehr.JTOpenContrib.QCDemo.QCMgrViewer ();
    setLayout (new java.awt.BorderLayout ());
    setPreferredSize (new java.awt.Dimension(600, 400));

    jTabbedPane1.setPreferredSize (new java.awt.Dimension(450, 350));

      qCCommandPanel1.setPreferredSize (new java.awt.Dimension(450, 380));
      qCCommandPanel1.setName ("");
      qCCommandPanel1.setToolTipText ("Uses an AS400 Command Button to execute a command on a server.");
  
      jTabbedPane1.addTab ("Command", null, qCCommandPanel1, "Click here for Command page.");
  
  
      jTabbedPane1.addTab ("IFS Viewer", qCIFSPanel1);
  
  
      jTabbedPane1.addTab ("User List", null, qCUserListPanel1, "Click here to get a list of users.");
  
      qCJobListPanel1.setPreferredSize (new java.awt.Dimension(450, 380));
      qCJobListPanel1.setToolTipText ("Shows Job List on system of your choice.");
  
      jTabbedPane1.addTab ("JobList", null, qCJobListPanel1, "Click here for Job List page.");
  
  
      jTabbedPane1.addTab ("Printer List", qCPrinterListPanel1);
  
  
      jTabbedPane1.addTab ("Spooled File Viewer", qCSpooledFileViewerPanel1);
  
  
      jTabbedPane1.addTab ("SQL Query Builder", qCSQLQueryBuilderPanel1);
  
      qCSQLResultSetTablePanel1.setToolTipText ("Shows the results of queries issued by the SQL Query Builder.");
  
      jTabbedPane1.addTab ("SQL Result Table", qCSQLResultSetTablePanel1);
  
  
      jTabbedPane1.addTab ("SQL Result Form", qCSQLResultSetFormPanel1);
  
  
      jTabbedPane1.addTab ("Data Queue Browser", qCDataQueuePanel1);
  
      qCMgrViewer1.setToolTipText ("View connection manager sessions with particular servers");
  
      jTabbedPane1.addTab ("Connection Manager Viewer", qCMgrViewer1);
  

    add (jTabbedPane1, java.awt.BorderLayout.CENTER);

  }//GEN-END:initComponents


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JTabbedPane jTabbedPane1;
  private com.SoftWoehr.JTOpenContrib.QCDemo.QCCommandPanel qCCommandPanel1;
  private com.SoftWoehr.JTOpenContrib.QCDemo.QCIFSPanel qCIFSPanel1;
  private com.SoftWoehr.JTOpenContrib.QCDemo.QCUserListPanel qCUserListPanel1;
  private com.SoftWoehr.JTOpenContrib.QCDemo.QCJobListPanel qCJobListPanel1;
  private com.SoftWoehr.JTOpenContrib.QCDemo.QCPrinterListPanel qCPrinterListPanel1;
  private com.SoftWoehr.JTOpenContrib.QCDemo.QCSpooledFileViewerPanel qCSpooledFileViewerPanel1;
  private com.SoftWoehr.JTOpenContrib.QCDemo.QCSQLQueryBuilderPanel qCSQLQueryBuilderPanel1;
  private com.SoftWoehr.JTOpenContrib.QCDemo.QCSQLResultSetTablePanel qCSQLResultSetTablePanel1;
  private com.SoftWoehr.JTOpenContrib.QCDemo.QCSQLResultSetFormPanel qCSQLResultSetFormPanel1;
  private com.SoftWoehr.JTOpenContrib.QCDemo.QCDataQueuePanel qCDataQueuePanel1;
  private com.SoftWoehr.JTOpenContrib.QCDemo.QCMgrViewer qCMgrViewer1;
  // End of variables declaration//GEN-END:variables

  /** Propagates an ErrorDialogAdapter to those as400.vaccess components which need it.
   * @param eda An instance of ErrorDialogAdapter already associated
   * with a suitable frame.
   */
  public void propagateEDA(com.ibm.as400.vaccess.ErrorDialogAdapter eda) {
    qCCommandPanel1.propagateEDA(eda);
    qCJobListPanel1.propagateEDA(eda);
    qCUserListPanel1.propagateEDA(eda);
    qCIFSPanel1.propagateEDA(eda);
    qCPrinterListPanel1.propagateEDA(eda);
    qCSpooledFileViewerPanel1.propagateEDA(eda);
    qCSQLQueryBuilderPanel1.propagateEDA(eda);
    qCSQLResultSetTablePanel1.propagateEDA(eda);
  }

  private void setManagers() {
    qCCommandPanel1.setManager(manager);
    qCJobListPanel1.setManager(manager);
    qCUserListPanel1.setManager(manager);
    qCIFSPanel1.setManager(manager);
    qCPrinterListPanel1.setManager(manager);
    qCSpooledFileViewerPanel1.setManager(manager);
    qCMgrViewer1.setManager(manager);
  }
}
