/*
 * QCPartnerFrame.java
 *
 * Created on August 21, 2000, 10:59 AM
 */

package com.SoftWoehr.JTOpenContrib.QCDemo;

/** A frame to open QCOpNav/QCDemo in when it's launched from another app.
 * @author jax
 * @version 1.1
 */
public class QCPartnerFrame extends javax.swing.JFrame {

  /** Error dialog for the as400 vaccess classes to share.
   */
  private com.ibm.as400.vaccess.ErrorDialogAdapter errorDialogAdapter;

  /** Manager to propagate for connections */
  private com.SoftWoehr.JTOpenContrib.connectionmgr.Mgr manager;

  /** Our icon image */
  private javax.swing.ImageIcon icon;

  /** Creates new form QCPartnerFrame */
  public QCPartnerFrame() {
    initComponents ();
    initStuff ();
    pack ();
  }

  /** Creates new form QCPartnerFrame and assigns manager
   * @param mgr The manager
   */
  public QCPartnerFrame(com.SoftWoehr.JTOpenContrib.connectionmgr.Mgr mgr) {
    manager = mgr;
    initComponents ();
    initStuff ();
    loadIcon("com/SoftWoehr/images/qcopnav.jpg", "QCOpNav Icon");
    pack ();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    qCNotebookPanel1 = new com.SoftWoehr.JTOpenContrib.QCDemo.QCNotebookPanel(manager, this);
    setTitle ("SoftWoehr QCOpNav 1.1");
    addWindowListener (new java.awt.event.WindowAdapter () {
      public void windowClosing (java.awt.event.WindowEvent evt) {
        exitForm (evt);
      }
    }
    );



    getContentPane ().add (qCNotebookPanel1, java.awt.BorderLayout.CENTER);

  }//GEN-END:initComponents

  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
    this.setVisible(false);
  }//GEN-LAST:event_exitForm

  /** Launch a partner frame for testing.
   * @param args the command line arguments
   */
  public static void main (String args[]) {
    new QCPartnerFrame ().show ();
  }


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private com.SoftWoehr.JTOpenContrib.QCDemo.QCNotebookPanel qCNotebookPanel1;
  // End of variables declaration//GEN-END:variables

  private void initStuff () {
    errorDialogAdapter = new com.ibm.as400.vaccess.ErrorDialogAdapter(this);
    qCNotebookPanel1.propagateEDA(errorDialogAdapter);
  }

  /************/
  /* The Icon */
  /************/

  private boolean loadIcon (String iconPath, String description) {
    boolean result = false;
    java.net.URL iconURL = ClassLoader.getSystemResource(iconPath);
    if (iconURL != null) {
      icon = new javax.swing.ImageIcon(iconURL, description);
      if (null != icon)
      {
        setIconImage(icon.getImage());
        result = true;
      }
    }
    return result;
  }

}