/*
 * QCTopFrame.java
 *
 * Created on July 15, 2000, 9:24 PM
 *
 * This is free open source software distributed under the IBM Public License found
 * on the World Wide Web at http://oss.software.ibm.com/developerworks/opensource/license10.html
 * Copyright *C* 2000, Jack J. Woehr, PO Box 51, Golden, CO 80402-0051 USA jax@well.com
 * Copyright *C* 2000, International Business Machines Corporation and others. All Rights Reserved.
 */

package com.SoftWoehr.JTOpenContrib.QCDemo;

/** The top-level frame for the QCDemo.
 * @author jax
 * @version 1.0
 */
public class QCTopFrame extends javax.swing.JFrame {

  /** Error dialog for the as400 vaccess classes to share.
   */
  public com.ibm.as400.vaccess.ErrorDialogAdapter errorDialogAdapter;

  /** Our icon image */
  private javax.swing.ImageIcon icon;

  /** Creates new form QCTopFrame */
  public QCTopFrame() {
    initComponents ();
    initStuff();
    initMenus();
    loadIcon("com/SoftWoehr/images/qcopnav.jpg", "QCOpNav Icon");
    pack ();
   }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    fileMenuBar = new javax.swing.JMenuBar ();
    fileMenu = new javax.swing.JMenu ();
    qCNotebookPanel1 = new com.SoftWoehr.JTOpenContrib.QCDemo.QCNotebookPanel(new com.SoftWoehr.JTOpenContrib.connectionmgr.Mgr (), this);

      fileMenu.setText ("File");
  
      fileMenuBar.add (fileMenu);
    setTitle ("SoftWoehr QCDemo 1.1");
    addWindowListener (new java.awt.event.WindowAdapter () {
      public void windowClosing (java.awt.event.WindowEvent evt) {
        exitForm (evt);
      }
    }
    );

    qCNotebookPanel1.setMinimumSize (new java.awt.Dimension(600, 400));


    getContentPane ().add (qCNotebookPanel1, java.awt.BorderLayout.CENTER);

    setJMenuBar (fileMenuBar);

  }//GEN-END:initComponents

  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
    System.exit (0);
  }//GEN-LAST:event_exitForm

  /** Run QCDemo.
   * @param args the command line arguments
   */
  public static void main (String args[]) {
    new QCTopFrame ().show ();
  }

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JMenuBar fileMenuBar;
  private javax.swing.JMenu fileMenu;
  private com.SoftWoehr.JTOpenContrib.QCDemo.QCNotebookPanel qCNotebookPanel1;
  // End of variables declaration//GEN-END:variables

  private void initStuff () {
    errorDialogAdapter = new com.ibm.as400.vaccess.ErrorDialogAdapter(this);
    qCNotebookPanel1.propagateEDA(errorDialogAdapter);
  }

  private void initMenus () {
    javax.swing.JMenuItem exitItem = new javax.swing.JMenuItem("Exit", java.awt.event.KeyEvent.VK_X);
    javax.swing.JMenuItem aboutItem = new javax.swing.JMenuItem("About", java.awt.event.KeyEvent.VK_A);
    exitItem.addActionListener(new java.awt.event.ActionListener () {
      public void actionPerformed(java.awt.event.ActionEvent a) {
        System.exit(0);
      }
    });
    aboutItem.addActionListener(new java.awt.event.ActionListener () {
      public void actionPerformed(java.awt.event.ActionEvent a) {
        javax.swing.JOptionPane.showMessageDialog(null, "SoftWoehr QCDemo 1.0\nCopyright *C* 2000, Jack J. Woehr jax@well.com http://www.well.com/user/jax/SoftWoehr\nCopyright *C* 2000 International Business Machines Corporation and others. All Rights Reserved.", "About QCDemo 1.0", javax.swing.JOptionPane.INFORMATION_MESSAGE);
      }
    });
    fileMenu.add(exitItem);
    fileMenu.add(aboutItem);
  }

  /************/
  /* The Icon */
  /************/

  private boolean loadIcon (String iconPath, String description) {
    boolean result = false;
    java.net.URL iconURL = ClassLoader.getSystemResource(iconPath);
    if (iconURL != null) {
      icon = new javax.swing.ImageIcon(iconURL, description);
      if (null != icon)
      {
        setIconImage(icon.getImage());
        result = true;
      }
    }
    return result;
  }

}
