/*
 * ServiceHash.java
 *
 * Created on July 12, 2000, 3:50 PM
 *
 * This is free open source software distributed under the IBM Public License found
 * on the World Wide Web at http://oss.software.ibm.com/developerworks/opensource/license10.html
 * Copyright *C* 2000, Jack J. Woehr, PO Box 51, Golden, CO 80402-0051 USA jax@well.com
 * Copyright *C* 2000, International Business Machines Corporation and others. All Rights Reserved.
 */

package com.SoftWoehr.JTOpenContrib.connectionmgr;

import java.util.*;

/**
 *
 * @author  jax
 * @version 1.1
 */
public class ServiceHash extends Object {

  private Hashtable serviceSessions;

  /** Creates new ServiceHash */
  public ServiceHash() {
    serviceSessions = new Hashtable();
  }

  /** Clear all keys
   * @throws UnsupportedOperationException
   */
  public void clear () throws UnsupportedOperationException {
    serviceSessions.clear();
  }

  /** Map in an object
   * @param key
   * @param object
   * @return The AS400 passed in as an argument
   */
  public com.ibm.as400.access.AS400 put(ServiceRecord key, com.ibm.as400.access.AS400 object) {
    serviceSessions.put(key, object);
    return object;
  }

  /** Get a server by name
   * @param key
   * @return The corresponding AS400 object
   */
  public com.ibm.as400.access.AS400 get(ServiceRecord key) {
    return (com.ibm.as400.access.AS400) serviceSessions.get(key);
  }

  /** Remove a server by name
   * @param key The service record to remove
   * @return The removed AS400 corresponding to the service record
   */
  public com.ibm.as400.access.AS400 remove(ServiceRecord key) {
    return (com.ibm.as400.access.AS400) serviceSessions.remove(key);
  }

  /** Contains the server named?
   * @param key
   * @return true if contains the named server
   */
  public boolean containsServiceRecord(ServiceRecord key) {
    return serviceSessions.containsKey(key);
  }

  /** Contains reference to the identical unique AS400 object
   * @param as400
   * @return true if the AS400 is in the manager collection
   */
  public boolean containsServer(com.ibm.as400.access.AS400 as400) {
    return serviceSessions.containsValue(as400);
  }

  /** Are any clients left of system <I>as400</I> using service <I>service</I>?
   * @param as400 An AS400 system which might currently be connected.
   * @param service One of the AS400 service constants.
   * @return <B>true</B> if any client is still active on system <I>as400</I> using service <I>service</I>.
   */
  public boolean anyServiceClients(com.ibm.as400.access.AS400 as400,int service) {
    return false;
  }
  /** Number of elements
   * @return number of service sessions
   */
  public int size () {
    return serviceSessions.size();
  }

  /** All service records
   * @return number of service session keys
   */
  public Enumeration keys () {
    return serviceSessions.keys();
  }

  /** Enumeration of elements elements
   * @return number of serviceSession elements
   */
  public Enumeration elements () {
    return serviceSessions.elements();
  }

  /** Is empty?
   * @return true if no sessions
   */
  public boolean isEmpty () {
    return serviceSessions.isEmpty();
  }

}
